/* REXX */
/*-------------------------------------------------------*/
/* Command file to update VATC server install with              */
/*   V3hotfix3 for                                                    */
/* Renames updated files to *.bk1 and copies new files         */
/*  from a V3hotfix.  Rebind step is included for whatever      */
/*  family is set in TC_FAMILY.  User can decline rebind        */
/*------------------------------------------------------*/

'@echo off'
do while queued() > 0
   pull junk
end /* do */
/* call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs */

lessmsg = ' >NUL 2>&1 '
here = directory()
back3 = '1'  /* backup extension for changed files */

env = 'Environment' /* assume windows */
opSys = 'win'
parse source platform . .
if platform = 'OS/2' then
   do
    env = 'OS2ENVIRONMENT'
    opSys = 'os2'
 end

TCdir = value( 'TC_HOME',, env )
TCfam = value( 'TC_FAMILY',,env )

TCdll = TCdir'\dll'
TCexe = TCdir'\bin'
TCcfg = TCdir'\NLS\CFG'
TCmsg = TCdir'\nls\msg\enu'
TCenu = TCdir'\enu'
TCsamples = TCdir'\samples'

if stream(TCdll,'c','query datetime') = '' then do
  say 'Cannot find Team Connection directory, tried using ' TCdir
  say 'Stopping'
  EXIT
end /* do */

/* copy readme renamed to see what HF is on EASILY */
newfile = 'readme.HF'||back3
orgfile = 'i302hotfix'||back3||'readme.txt'
'erase readme.hf*  >NUL 2>&1 '
'copy 'orgfile ' ' TCdir'\'newfile ' NUL 2>@1 '
say ' Copy 'orgfile' as ' newfile ' to ' TCdir

/* common files to server and client */
call directory TCdir
here1 = here'\COMMON'
call docopy 'readme.txt', here1
call directory TCenu
call docopy 'readme.txt', here1
call directory TCmsg
call docopy 'teamcv3.cat', here1

/* check for server structure */
TCchk = TCdir'\NLS\CFG\_tcbase.bnd'

if stream(TCchk,'c','query exists') <> '' then do
/* do dlls first */
  here1 = here'\SERVER'
  call directory TCdll
  'erase *.hf*  >NUL 2>&1 ' /* erase all previous HF dlls'*/
  if opSys = 'win' then do
    call docopy 'FHMHTTPD.DLL', here1
    call docopy 'FHMKRNL.DLL', here1
    call docopy 'FHMMYSTC.DLL', here1
    call docopy 'FHCMMYSTC.DLL', here1
    call docopy 'FHMSERVR.DLL', here1
   end
  else do  /* OS2 */
    call docopy 'FHCHTTPD.DLL', here1
    call docopy 'FHCKRNL.DLL', here1
    call docopy 'FHCMYSTC.DLL', here1
    call docopy 'FHCSERVR.DLL', here1
   end
/* exe now */
  call directory TCexe
  'erase *.hf*  >NUL 2>&1 ' /* erase all previous HF exe's */
    call docopy 'MIGTC.EXE', here1
/*  call docopy 'FHCIRTUP.EXE', here1 */
/*  call docopy 'FHCFUPDV.EXE', here1 */
/* now SAMPLES */
   call directory TCsamples
   call docopy 'mc0.c', here1
/* now bind files */
  call directory TCcfg
  'erase *.hf*  >NUL 2>&1 ' /* erase all previous HF files */
  call docopy 'adlink.bnd', here1
  call docopy 'admerge.bnd', here1
  call docopy 'adobject.bnd', here1
  call docopy 'adsqlsvr.bnd', here1
  call docopy 'advroot.bnd', here1
  call docopy 'fhccntxt.bnd', here1
  call docopy 'fhcfgfld.bnd', here1
  call docopy 'fhcversn.bnd', here1
  call docopy 'session.bnd', here1
  call docopy 'tccollc.bnd', here1
  call docopy 'tctrans.bnd', here1
  call docopy '_tcbase.bnd', here1

  say '*********ATTENTION************************'
  say ' You must re-bind the family data base now.'
  say ' Some errors are acceptable. '
  say ' Please refer to the hotfix readme file'
  say '******************************************'
  say ' '
  say ' '
  say 'TC_FAMILY is set to ' TCfam
  say 'Proceed to update ' TCfam' Yes|No ?'
  parse upper pull reply
  reply = strip(reply)
  if reply = 'YES' | reply = 'Y' then do
     say ' Have you completed DB2 backup of 'TCfam ' Yes|No ?'
     parse upper pull reply
     reply = strip(reply)
     if reply = 'YES' | reply = 'Y' then do
        say 'Running FHCIRT for ' TCfam
        fhcirt TCcfg'\*.bnd '
/*        say 'Run FHCFUPDV for ' TCfam */
        say ' See the VATC Administration Guide. '
/*        fhcfupdv part.tbl partview */
/*        fhcfupdv part.tbl partfullview */
        say 'For optimal performance '
        say 'We suggest running REORG, RUNSTATS  '
        say ' and re-binding 'TCfam
        say 'You may use analyzer.cmd as described '
        say ' in the i302hotfix1readme.txt file.'
        say '*****************************************'
        say 'These steps must be done for each family!'
        say '*****************************************'
     end /* do reply */
  end /* do YES or Y */
end /* do if TCChk exists */

TCchk1 = TCdir'\bin\teamcgui.exe'
if stream(TCchk1,'c','query exists') <> '' then do
/* copy Client dlls */
  here1 = here'\CLIENT'
  call directory(TCdll)
  'erase *.hf*  >NUL 2>&1 ' /* erase all previous HF dlls'*/
    if opSys = 'win' then do
      call docopy 'fhmrscli.dll', here1
     end
  /* need these for both */
  call docopy 'fhcrscli.dll', here1
end /* if client */

call directory here
say 'Finished '
return

docopy: procedure expose back3 bkname
  file = arg(1)
  fromdir = arg(2)

  parse var file fname '.' ftype
  newft = substr(ftype,2,2)
  newft = back3 || newft
  bkname = fname ||'.' || newft
  say 'Renaming ' file ' to ' bkname
  'rename' file bkname' >NUL 2>&1 '  /* rename so original backup is never overwritten */
  say 'Copying ' file
  copy fromdir'\'file
 return

